/*
Copyright (C) Matthew 'pagan' Baranowski & Sander 'FireStorm' van Rossen

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#include <stdio.h>
#include "DiskIO.h"

void putLittle16 ( short num , FILE *f )
{
	union
	{
		struct
		{
	        unsigned char    b1, b2;
		};
		unsigned short	 i1;
	} u;

	u.i1 = num;

	fputc( u.b1, f );
	fputc( u.b2, f );
}

short getLittle16 (FILE *f)
{
	union
	{
		struct
		{
	        unsigned char    b1, b2;
		};
		unsigned short	 i1;
	} u;

	u.b1 = fgetc(f);
	u.b2 = fgetc(f);

	return u.i1;
}

void putLittle32 ( long num , FILE *f )
{
	union 
	{
		struct
		{
	        unsigned char    b1, b2, b3, b4;
		};
		unsigned long	 i1;
	} u;

	u.i1 = num;

	fputc( u.b1, f );
	fputc( u.b2, f );
	fputc( u.b3, f );
	fputc( u.b4, f );
}

long getLittle32 (FILE *f)
{
	union 
	{
		struct
		{
	        unsigned char    b1, b2, b3, b4;
		};
		unsigned long	 i1;
	} u;

	u.b1 = fgetc(f);
	u.b2 = fgetc(f);
	u.b3 = fgetc(f);
	u.b4 = fgetc(f);

	return u.i1;
}

void putLittleFloat( float num  , FILE *f )//32bit floating point number
{
	union 
	{
		struct
		{
	        unsigned char    b1, b2, b3, b4;
		};
		float	 f1;
	} u;

	u.f1 = num;

	fputc( u.b1, f );
	fputc( u.b2, f );
	fputc( u.b3, f );
	fputc( u.b4, f );
}

float getLittleFloat (FILE *f) //32bit floating point number
{
	union 
	{
		struct
		{
			unsigned char    b1, b2, b3, b4;
		};
		float	 f1;
	} u;

	u.b1 = fgetc(f);
	u.b2 = fgetc(f);
	u.b3 = fgetc(f);
	u.b4 = fgetc(f);

	return u.f1;
}

void putBig16 ( short num , FILE *f )
{
	union 
	{
		struct
		{
	        unsigned char    b1, b2, b3, b4;
		};
		short	 i1;
	} u;

	u.i1 = num;

	fputc( u.b2, f );
	fputc( u.b1, f );
}

short getBig16 (FILE *f)
{
	union 
	{
		struct
		{
	        unsigned char    b1, b2;
		};
		unsigned short	 i1;
	} u;

	u.b2 = fgetc(f);
	u.b1 = fgetc(f);

	return u.i1;
}

void putBig32 ( long num , FILE *f )
{
	union 
	{
		struct
		{
	        unsigned char    b1, b2, b3, b4;
		};
		long	 i1;
	} u;

	u.i1 = num;

	fputc( u.b4, f );
	fputc( u.b3, f );
	fputc( u.b2, f );
	fputc( u.b1, f );
}

long getBig32 (FILE *f)
{
	union 
	{
		struct
		{
	        unsigned char    b1, b2, b3, b4;
		};
		unsigned long	 i1;
	} u;

	u.b4 = fgetc(f);
	u.b3 = fgetc(f);
	u.b2 = fgetc(f);
	u.b1 = fgetc(f);

	return u.i1;
}

void putBigFloat ( float num , FILE *f ) //32bit floating point number
{
	union 
	{
		struct
		{
	        unsigned char    b1, b2, b3, b4;
		};
		float	 f1;
	} u;

	u.f1 = num;

	fputc( u.b4, f );
	fputc( u.b3, f );
	fputc( u.b2, f );
	fputc( u.b1, f );
}

float getBigFloat (FILE *f) //32bit floating point number
{
	union 
	{
		struct
		{
			unsigned char    b1, b2, b3, b4;
		};
		float	 f1;
	} u;

	u.b4 = fgetc(f);
	u.b3 = fgetc(f);
	u.b2 = fgetc(f);
	u.b1 = fgetc(f);

	return u.f1;
}
