/**********************************************************************
 *<
	FILE: ExportMD3.cpp

	DESCRIPTION:	Appwizard generated plugin

	CREATED BY: 

	HISTORY: 

 *>	Copyright (c) 1997, All Rights Reserved.
 **********************************************************************/

#include "ExportMD3.h"

#ifdef _MAX2
#	define EXPORTMD3_CLASS_ID	Class_ID(0x7ad2cace, 0x65f5ea3b)
#else
#	define EXPORTMD3_CLASS_ID	Class_ID(0x35a0cc95, 0x7098cbf0)
#endif

int	g_ticks_per_frame;
int g_total_frames = 0;

TagName g_relative_to_tag	= tag_none;

bool g_smart_paths			= true;
bool g_ignore_bip			= true;	
bool g_only_objects_named	= false;
bool g_only_tags_named		= false;
bool g_show_warnings		= false;

std::list<std::string>	gl_valid_names;
std::list<std::string>	gl_valid_tags;
std::list<Range>		gl_frame_ranges;

class ExportMD3 : public SceneExport {
	public:
		static HWND hParams;

		int				ExtCount();					// Number of extensions supported
		const TCHAR *	Ext(int n);					// Extension #n (i.e. "3DS")
		const TCHAR *	LongDesc();					// Long ASCII description (i.e. "Autodesk 3D Studio File")
		const TCHAR *	ShortDesc();				// Short ASCII description (i.e. "3D Studio")
		const TCHAR *	AuthorName();				// ASCII Author name
		const TCHAR *	CopyrightMessage();			// ASCII Copyright message
		const TCHAR *	OtherMessage1();			// Other message #1
		const TCHAR *	OtherMessage2();			// Other message #2
		unsigned int	Version();					// Version number * 100 (i.e. v3.01 = 301)
		void			ShowAbout(HWND hWnd);		// Show DLL's "About..." box
#ifdef _MAX2
		int				DoExport(const TCHAR *name,ExpInterface *ei,Interface *gi, int suppressPrompts=FALSE);
#else
		int				DoExport(const TCHAR *name,ExpInterface *ei,Interface *gi, BOOL suppressPrompts=FALSE, DWORD options=0);	// Export file
		BOOL			SupportsOptions(int ext, DWORD options);
#endif
		//Constructor/Destructor
		ExportMD3();
		~ExportMD3();		
};

#ifdef _MAX2
class ExportMD3ClassDesc:public ClassDesc {
#else
class ExportMD3ClassDesc:public ClassDesc2 {
#endif
	public:
	int 			IsPublic() {return 1;}
	void *			Create(BOOL loading = FALSE) {return new ExportMD3();}
	const TCHAR *	ClassName() {return GetString(IDS_CLASS_NAME);}
	SClass_ID		SuperClassID() {return SCENE_EXPORT_CLASS_ID;}
	Class_ID		ClassID() {return EXPORTMD3_CLASS_ID;}
	const TCHAR* 	Category() {return GetString(IDS_CATEGORY);}
	const TCHAR*	InternalName() { return _T("ExportMD3"); }	// returns fixed parsable name (scripter-visible name)
	HINSTANCE		HInstance() { return hInstance; }				// returns owning module handle
};

static ExportMD3ClassDesc ExportMD3Desc;
#ifdef _MAX2
ClassDesc* GetExportMD3Desc() {return &ExportMD3Desc;}
#else
ClassDesc2* GetExportMD3Desc() {return &ExportMD3Desc;}
#endif

BOOL CALLBACK ExportMD3OptionsDlgProc(HWND hWnd,UINT message,WPARAM wParam,LPARAM lParam) {
	static ExportMD3 *imp = NULL;

	const min = 0;
	const max = 400;

	static int from = 0;
	static int to	= 0;

	switch(message) {
		case WM_INITDIALOG:
			imp = (ExportMD3 *)lParam;
			CenterWindow(hWnd,GetParent(hWnd));

			gl_valid_names.clear();
			gl_valid_tags.clear();
			gl_frame_ranges.clear();

			SendDlgItemMessage( hWnd, IDC_CHECK_PATHS,			BM_SETCHECK,	(WPARAM) true, 0L );
			SendDlgItemMessage( hWnd, IDC_CHECK_IGNOREBIP,		BM_SETCHECK,	(WPARAM) true, 0L );
			SendDlgItemMessage( hWnd, IDC_CHECK_TAGNAMES,		BM_SETCHECK,	(WPARAM) false, 0L );
			SendDlgItemMessage( hWnd, IDC_CHECK_OBJECTNAMES,	BM_SETCHECK,	(WPARAM) false, 0L );
			SendDlgItemMessage( hWnd, IDC_CHECK_WARNINGS,		BM_SETCHECK,	(WPARAM) true, 0L );
			CheckRadioButton( hWnd, IDC_RADIO_TAG_NONE, IDC_RADIO_TAG_FLOOR, IDC_RADIO_TAG_NONE );
			return TRUE;

		case WM_COMMAND:
			if( HIWORD(wParam) == BN_CLICKED )
				if( LOWORD(wParam) == IDC_BUTTON_EXPORT )
					PostMessage( hWnd, WM_CLOSE, 0, 0 );
			return TRUE;

		case WM_CLOSE:
			g_smart_paths		= ( SendDlgItemMessage( hWnd, IDC_CHECK_PATHS,			BM_GETCHECK, 0, 0L) == BST_CHECKED );
			g_ignore_bip		= ( SendDlgItemMessage( hWnd, IDC_CHECK_IGNOREBIP,		BM_GETCHECK, 0, 0L) == BST_CHECKED );
			g_only_objects_named= ( SendDlgItemMessage( hWnd, IDC_CHECK_OBJECTNAMES,	BM_GETCHECK, 0, 0L) == BST_CHECKED );
			g_only_tags_named	= ( SendDlgItemMessage( hWnd, IDC_CHECK_TAGNAMES,		BM_GETCHECK, 0, 0L) == BST_CHECKED );
			g_show_warnings		= ( SendDlgItemMessage( hWnd, IDC_CHECK_WARNINGS,		BM_GETCHECK, 0, 0L) == BST_CHECKED );
				
			if( IsDlgButtonChecked(hWnd, IDC_RADIO_TAG_NONE) == BST_CHECKED )
				g_relative_to_tag = tag_none;
			else if( IsDlgButtonChecked(hWnd, IDC_RADIO_TAG_HEAD) == BST_CHECKED )
				g_relative_to_tag = tag_head;
			else if( IsDlgButtonChecked(hWnd, IDC_RADIO_TAG_TORSO) == BST_CHECKED )
				g_relative_to_tag = tag_torso;
			else
				g_relative_to_tag = tag_floor;


			// Parse the frames to export
			{
				char ranges_named[128];
				char * token;
				char * subtoken;
				Range range;
				g_total_frames = 0;

				GetDlgItemText( hWnd, IDC_EDIT_FRAMES, ranges_named, 127 );

				token = strtok( ranges_named, "," );
				while( token != NULL )
				{
					// get a range
					subtoken = strchr( token, '-' );
					if( subtoken != NULL )
					{
						// find a range
						*subtoken = '\0';
						range.first	= atoi( token );
						range.last	= atoi( subtoken+1 );
					}
					else
					{
						// a single value
						range.first	= atoi( token );
						range.last	= range.first;
					}	
					g_total_frames += range.last - range.first + 1;
					gl_frame_ranges.push_back( range );
					token = strtok( NULL, "," );
				}
			}

			// If 'only_objects_named' parse the names
			if( g_only_objects_named )
			{
				char objects_named[128];
				char * token;

				GetDlgItemText( hWnd, IDC_EDIT_NAMES, objects_named, 127 );

				token = strtok( objects_named, "," );
				while( token != NULL )
				{
					gl_valid_names.push_back( token );
					token = strtok( NULL, "," );
				}
			}

			// If 'only_tags_named' parse the names
			if( g_only_tags_named )
			{
				char tags_named[128];
				char * token;

				GetDlgItemText( hWnd, IDC_EDIT_TAGS, tags_named, 127 );

				token = strtok( tags_named, "," );
				while( token != NULL )
				{
					gl_valid_tags.push_back( token );
					token = strtok( NULL, "," );
				}
			}

			EndDialog(hWnd, 0);
			return TRUE;
	}
	return FALSE;
}


//--- ExportMD3 -------------------------------------------------------
ExportMD3::ExportMD3()
{

}

ExportMD3::~ExportMD3() 
{

}

int ExportMD3::ExtCount()
{
	//TODO: Returns the number of file name extensions supported by the plug-in.
	return 1;
}

const TCHAR *ExportMD3::Ext(int n)
{		
	//TODO: Return the 'i-th' file name extension (i.e. "3DS").
	return _T("MD3");
}

const TCHAR *ExportMD3::LongDesc()
{
	//TODO: Return long ASCII description (i.e. "Targa 2.0 Image File")
	return _T("Quake III Arena Model File");
}
	
const TCHAR *ExportMD3::ShortDesc() 
{			
	//TODO: Return short ASCII description (i.e. "Targa")
	return _T("Quake III");
}

const TCHAR *ExportMD3::AuthorName()
{			
	//TODO: Return ASCII Author name
	return _T("Pop N Fresh");
}

const TCHAR *ExportMD3::CopyrightMessage() 
{	
	// Return ASCII Copyright message
	return _T("(c) 1999 Kelvin McDowell");
}

const TCHAR *ExportMD3::OtherMessage1() 
{		
	//TODO: Return Other message #1 if any
	return _T("");
}

const TCHAR *ExportMD3::OtherMessage2() 
{		
	//TODO: Return other message #2 in any
	return _T("");
}

unsigned int ExportMD3::Version()
{				
	//TODO: Return Version number * 100 (i.e. v3.01 = 301)
	return 100;
}

void ExportMD3::ShowAbout(HWND hWnd)
{			
	// Optional
}

#ifdef _MAX2
int	ExportMD3::DoExport(const TCHAR *name,ExpInterface *ei, Interface *gi,
						BOOL suppressPrompts)
#else
int	ExportMD3::DoExport(const TCHAR *name,ExpInterface *ei, Interface *gi,
						BOOL suppressPrompts, DWORD options)
#endif
{
#ifdef _MAX2
	DWORD options = 0;
#endif
	//TODO: Implement the actual file import here and 
	//		return TRUE If the file is imported properly
	g_ticks_per_frame	= GetTicksPerFrame();

	
	if(!suppressPrompts)
		DialogBoxParam(hInstance, 
				MAKEINTRESOURCE(IDD_PANEL), 
				GetActiveWindow(), 
				ExportMD3OptionsDlgProc, (LPARAM)this);

	return DoExportMD3( name, ei, gi, suppressPrompts, options );
}
	
#ifndef _MAX2
BOOL ExportMD3::SupportsOptions(int ext, DWORD options)
{
	assert(ext == 0);	// We only support one extension
	return(options == SCENE_EXPORT_SELECTED) ? TRUE : FALSE;
}
#endif


// Return a pointer to a TriObject given an INode or return NULL
// if the node cannot be converted to a TriObject
TriObject* GetTriObjectFromNode(INode *node, TimeValue t, bool &deleteIt)
{
	deleteIt = false;
	Object *obj = node->EvalWorldState(t).obj;
	if (obj->CanConvertToType(Class_ID(TRIOBJ_CLASS_ID, 0))) { 
		TriObject *tri = (TriObject *) obj->ConvertToType(t, 
			Class_ID(TRIOBJ_CLASS_ID, 0));
		// Note that the TriObject should only be deleted
		// if the pointer to it is not equal to the object
		// pointer that called ConvertToType()
		if (obj != tri) deleteIt = true;
		return tri;
	}
	else {
		return 0;
	}
}

