/**********************************************************************
 *<
	FILE: ExportMD3.h

	DESCRIPTION:	Template Utility

	CREATED BY:

	HISTORY:

 *>	Copyright (c) 1997, All Rights Reserved.
 **********************************************************************/

#ifndef __EXPORTMD3__H
#define __EXPORTMD3__H

#include "Max.h"
#include "resource.h"
#include "istdplug.h"

#ifdef _MAX2
#include "iparamb.h"
#include "iparamm.h"
#else
#include "iparamb2.h"
#include "iparamm2.h"
#endif

#include "stdmat.h"

#include <direct.h>
#include <commdlg.h>

#include <list>
#include <string>

enum TagName
{
	tag_none,
	tag_head,
	tag_torso,
	tag_floor,
};

struct Range
{
	unsigned int first;
	unsigned int last;
};


const float FLOOR_LEVEL = -23.0f;

extern TCHAR *GetString(int id);

extern HINSTANCE hInstance;

extern int g_ticks_per_frame;
extern int g_total_frames;

extern TagName g_relative_to_tag;

extern bool g_smart_paths;
extern bool g_ignore_bip;
extern bool g_only_objects_named;
extern bool g_only_tags_named;
extern bool g_show_warnings;

extern std::list<std::string>	gl_valid_names;
extern std::list<std::string>	gl_valid_tags;
extern std::list<Range>			gl_frame_ranges;

TriObject*	GetTriObjectFromNode(INode *node, TimeValue t, bool &deleteIt);

int	DoExportMD3(const TCHAR *name,ExpInterface *ei, Interface *gi,
						BOOL suppressPrompts, DWORD options);

#endif // __EXPORTMD3__H
